%define major 1
%define pcre_major 1
%define pcrecpp_major 0
%define pcreposix_major 1
%define pcreposix_compat_major 0
%define libname_orig	lib%{name}
%define libname16_orig    lib%{name}16
%define libname32_orig    lib%{name}32
%define libname	%mklibname pcre %{pcre_major}
%define libname16 %mklibname pcre 16 %{pcrecpp_major}
%define libname32 %mklibname pcre 32 %{pcrecpp_major}
%define libnamecpp %mklibname pcrecpp %{pcrecpp_major}
%define libnameposix %mklibname pcreposix %{pcreposix_major}
%define libnameposix_compat %mklibname pcreposix %{pcreposix_compat_major}
%define develname %mklibname -d pcre 0
%define develcpp %mklibname -d pcrecpp
%define develposix %mklibname -d pcreposix

%define build_pcreposix_compat 1

Summary: 	Perl-compatible regular expression library
Summary(de):	PCRE ist eine Perl-kompatible Bibliothek für reguläre Ausdrücke
Name:	 	pcre
Version:	8.45
Release:	%mkrel 1
License: 	BSD-Style
Group:  	File tools
URL: 		http://www.pcre.org/
Source0:	http://downloads.sourceforge.net/pcre/%{name}-%{version}.tar.xz
Requires: 	%{libname} = %{version}-%{release}
BuildRequires:	automake
Patch0:		pcre-0.6.5-fix-detect-into-kdelibs.patch
Patch1:		pcre-8.33-linkage-fix.patch
Patch4:		pcre-pcreposix-glibc-conflict.patch
Patch5:		bug2173.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
PCRE has its own native API, but a set of "wrapper" functions that are based on
the POSIX API are also supplied in the library libpcreposix. Note that this
just provides a POSIX calling interface to PCRE: the regular expressions
themselves still follow Perl syntax and semantics. 
This package contains a grep variant based on the PCRE library.

#german
%description -l de
PCRE hat eine eigene systemeigene API, aber eine Reihe von „Wrapper“ Funktionen, 
basieren auf der POSIX-API, sie werden auch in der libpcreposix Bibliothek mitgeliefert. 
Beachten Sie, dass dies nur eine aufrufende POSIX-Schnittstelle zu PCRE bereitstellt: 
die regulären Ausdrücke selbst folgen noch der Perl-Syntax und Semantik.

Dieses Paket enthält eine grep-Variante basierend auf der PCRE-Bibliothek. 


%package -n	%{libname}
Group:		System/Libraries
Summary:	Perl-compatible regular expression library
Requires(pre):	filesystem
Provides:	%{libname_orig} = %{version}-%{release}
Requires:	%{_lib}pcre-compatible0


%description -n	%{libname}
This package contains the shared library libpcre.


#german
%description -n	%{libname} -l de
PCRE ist eine Perl-kompatible Bibliothek für regulären Ausdrücke. PCRE hat eigene 
systemeigene API, aber setzt auf eine Reihe von „Wrapper“ Funktionen, die auf der 
POSIX-API basieren, und auch in der Bibliothek libpcreposix bereitgestellt werden. 
Beachten Sie, dass dies nur eine POSIX-aufgerufende Schnittstelle zu PCRE bereitstellt: 
Die regulären Ausdrücke selbst folgen der Perl Syntax und Semantik. Die Headerdatei 
für die Funktionen im Stil von POSIX werden mit pcreposix.h aufgerufen. Der offiziellen 
POSIX-Name ist Regex.h, aber ich riskiere nicht mögliche Problemen mit vorhandenen 
Dateien mit diesem Namen, indem sie auf diese Weise vergeben möchten. Um es mit einem 
vorhandenen Programm zu verwenden, wird die POSIX-API verwendet, Sie müssen sie umbenennen 
oder durch eine Verknüpfung verweist.



%package -n	%{develname}
Group:		Development/Libraries
Summary:	Headers and static lib for pcre development
Requires:	%{libname} = %{version}-%{release}
Provides:	pcre-devel = %{version}


%description -n	%{develname}
Install this package if you want do compile applications using the pcre
library.

#german
%description -n	%{develname} -l de
Installiere dieses Paket wenn du Programme compilieren möchtest welche die pcre 
Bibliothek verwenden.


%prep
%setup -q
%patch0 -p1 -b .detect-into-kdelibs
%patch1 -p1 -b .linkage-fix

%if %{build_pcreposix_compat}
  # pcre-pcreposix-glibc-conflict patch below breaks compatibility,
  # create a libpcreposix.so.0 without the patch
  cp -a . ../pcre-with-pcreposix_compat && mv ../pcre-with-pcreposix_compat .
%endif
%patch4 -p1 -b .symbol-conflict
%patch5 -p1 

%build
%if %{build_pcreposix_compat}
dirs="pcre-with-pcreposix_compat ."
%else
dirs="."
%endif
for i in $dirs; do
  cd $i
  mkdir -p m4
  autoreconf -fi
  %configure2_5x \
  	--disable-static \
	--enable-utf \
	--enable-unicode-properties \
    --enable-pcre8 \
    --enable-pcre16 \
    --enable-pcre32 \
	--enable-jit
  %make
  cd -
done



%install
rm -rf $RPM_BUILD_ROOT
%if %{build_pcreposix_compat}
%makeinstall_std -C pcre-with-pcreposix_compat
%endif
%makeinstall_std

%multiarch_binaries %{buildroot}%{_bindir}/pcre-config

mkdir -p $RPM_BUILD_ROOT/%_lib
mv $RPM_BUILD_ROOT/%_libdir/lib%{name}.so.%{major}.* $RPM_BUILD_ROOT/%_lib
cd $RPM_BUILD_ROOT/%_libdir
ln -s ../../%_lib/lib%{name}.so.%{major}.* .

# Remove unwanted files
rm -f %{buildroot}%{_docdir}/pcre/{AUTHORS,ChangeLog,COPYING,LICENCE,NEWS}
rm -f %{buildroot}%{_docdir}/pcre/{pcre-config.txt,pcre.txt,pcregrep.txt}
rm -f %{buildroot}%{_docdir}/pcre/{pcretest.txt,README}
rm -rf %{buildroot}%{_docdir}/pcre/html
rm -f %{buildroot}%{_libdir}/*.la


%files
%defattr(-,root,root)
%{_mandir}/man1/pcregrep.1*
%{_mandir}/man1/pcretest.1*
%{_bindir}/pcregrep  
%{_bindir}/pcretest

%files -n %{libname}
%defattr(-,root,root)
/%_lib/lib*.so.%{major}*
%{_libdir}/libpcre.so.%{pcre_major}*
%{_libdir}/libpcre16.so.%{pcrecpp_major}*
%{_libdir}/libpcre32.so.%{pcrecpp_major}*
%{_libdir}/libpcrecpp.so.%{pcrecpp_major}*
%{_libdir}/libpcreposix.so.%{pcreposix_major}*
%{_libdir}/libpcreposix.so.%{pcreposix_compat_major}*


%files -n %{develname}
%defattr(-,root,root)
%doc doc/html
%doc ChangeLog 
%{_libdir}/libpcre.so
%{_libdir}/libpcre16.so
%{_libdir}/libpcre32.so
%{_includedir}/pcre.h
%{_includedir}/pcre_*.h
%{_libdir}/pkgconfig/libpcre.pc
%{_libdir}/pkgconfig/libpcre16.pc
%{_libdir}/pkgconfig/libpcre32.pc
%{_bindir}/pcre-config
%multiarch %{multiarch_bindir}/pcre-config
%{_mandir}/man1/pcre-config.1*
%{_mandir}/man3/*.3*
%{_libdir}/libpcreposix.so
%{_mandir}/man3/pcreposix.3*
%{_includedir}/pcrecpp*.h
%{_libdir}/libpcrecpp.so
%{_libdir}/pkgconfig/libpcrecpp.pc
%{_mandir}/man3/pcrecpp.3*
%{_includedir}/pcreposix.h
%{_libdir}/libpcreposix.so
%{_libdir}/pkgconfig/libpcreposix.pc
%{_mandir}/man3/pcreposix.3*

%clean
rm -rf %{buildroot}

%changelog
* Sun Aug 08 2021 tex - 8.45-1pclos2021
- new version

* Fri Feb 28 2020 tex - 8.44-1pclos2020
- new version

* Fri Mar 22 2019 tex - 8.43-1pclos2019
- new version

* Tue Apr 17 2018 bb2 <bb2> - 8.42-1pclos2018
- new version

* Fri Sep 15 2017 bb2 <bb2> - 8.40-1pclos2017
- new version new gcc

* Thu Oct 09 2014 bb <bb> 8.36-1pclos2014
- update

* Mon Nov 04 2013 billybot <billybot> 8.33-1pclos2013
- update
